\chapter{Further improvements}
The chapter of benchmarking performance of the Duckiebots is by far not over. This thesis sets a baseline for benchmarking the hardware behavior. Still all used software plus the applied measurements have room for improvement. Some ideas are presented in this chapter. 
\section{Measurements}\label{sec:impr_meas}
\begin{itemize}
    \item Collect more data from more bots.
    \item Include localization system data.
    \item Add battery measurements to the score.
    \item Run benchmark using \verb+daffy+ as software release.
    \item Run the hardware compliance tool from Aleksander Petrov. Include its measurements.
\end{itemize}
\section{API}\label{sec:impr_api}
\begin{itemize}
    \item Incorporate other benchmark procedures e.g. Software Benchmark.
    \item Add authentication via the Duckietown token.
    \item Upload the data to an external host data storage.
    \item Cache overall score in order to reduce response time for resp. endpoint.
    \item Incorporate localization info.
    \item Use \verb+bjoern+ or similar as production \verb+WSGI+ (Web Server Gateway Interface) server, as the Flask development server is technically not recommended to run in a production environment. 
    \item Save/cache graphs, further reducing the response time.
    \item Allow filtering and ordering of the returned results by location, tester, etc.
\end{itemize}
\section{CLI}\label{sec:impr_cli}
\begin{itemize}
    \item Adjust Docker digests for \verb+daffy+, resp. \verb+daffy_new_deal+ container once it is released.
    \item Automated hardware compliance check.
    \item Invoke callbacks in separate threads.
    \item Display link to the new diagnostic result after the benchmark has been uploaded.
\end{itemize}
\section{Frontend}\label{sec:impr_fe}
\begin{itemize}
    \item Include frontend into the dashboard.
    \item Improve frontend, e.g. enable direct comparison between average and newly supplied benchmark or two benchmarks on a measurement-by-measurement basis.
    \item Frontend make responsive, especially the display of cards.
\end{itemize}